import{s as It,o as qt}from"../chunks/scheduler.f6b352c8.js";import{S as zt,i as Et,g as l,s,r as q,A as Ot,h as r,f as n,c as a,j as Ct,u as z,x as h,k as Lt,y as St,a as i,v as E,d as O,t as S,w as j,m as Ht,n as Pt}from"../chunks/index.7f38e934.js";import{T as Mt}from"../chunks/Tip.ae532637.js";import{H as Rt}from"../chunks/Heading.333929c4.js";import{E as jt}from"../chunks/EditOnGithub.c3245a01.js";function Bt(P){let o;return{c(){o=Ht("In this section, we dive into the inner workings of an AI agent—its ability to reason and plan. We’ll explore how the agent leverages its internal dialogue to analyze information, break down complex problems into manageable steps, and decide what action to take next. Additionally, we introduce the Re-Act approach, a prompting technique that encourages the model to think “step by step” before acting.")},l(p){o=Pt(p,"In this section, we dive into the inner workings of an AI agent—its ability to reason and plan. We’ll explore how the agent leverages its internal dialogue to analyze information, break down complex problems into manageable steps, and decide what action to take next. Additionally, we introduce the Re-Act approach, a prompting technique that encourages the model to think “step by step” before acting.")},m(p,d){i(p,o,d)},d(p){p&&n(o)}}}function Gt(P){let o;return{c(){o=Ht(`Recently we have seen an interest for reasoning. Models like Deepseek-R1 or OpenAI's o1 have been fine-tuned to  "think before answering".`)},l(p){o=Pt(p,`Recently we have seen an interest for reasoning. Models like Deepseek-R1 or OpenAI's o1 have been fine-tuned to  "think before answering".`)},m(p,d){i(p,o,d)},d(p){p&&n(o)}}}function Ut(P){let o,p,d,B,u,G,c,U,f,ht="Thoughts represent the <strong>Agent’s internal reasoning and planning processes</strong> to solve the task.",D,g,dt="This utilises the agent’s Large Language Model (LLM) capacity <strong>to analyze information when presented in it’s prompt</strong>.",N,b,ct="Think of it as the agent’s internal dialogue, where it considers the task at hand and strategizes its approach.",K,$,mt="The Agent’s thoughts are responsible for accessing current observations and decide what the next action(s) should be.",Q,v,ut="Through this process, the agent can <strong>break down complex problems into smaller, more manageable steps</strong>, reflect on past experiences, and continuously adjust its plans based on new information.",W,x,ft="Here are some examples of common thoughts:",F,w,gt="<thead><tr><th>Type of Thought</th> <th>Example</th></tr></thead> <tbody><tr><td>Planning</td> <td>“I need to break this task into three steps: 1) gather data, 2) analyze trends, 3) generate report”</td></tr> <tr><td>Analysis</td> <td>“Based on the error message, the issue appears to be with the database connection parameters”</td></tr> <tr><td>Decision Making</td> <td>“Given the user’s budget constraints, I should recommend the mid-tier option”</td></tr> <tr><td>Problem Solving</td> <td>“To optimize this code, I should first profile it to identify bottlenecks”</td></tr> <tr><td>Memory Integration</td> <td>“The user mentioned their preference for Python earlier, so I’ll provide examples in Python”</td></tr> <tr><td>Self-Reflection</td> <td>“My last approach didn’t work well, I should try a different strategy”</td></tr> <tr><td>Goal Setting</td> <td>“To complete this task, I need to first establish the acceptance criteria”</td></tr> <tr><td>Prioritization</td> <td>“The security vulnerability should be addressed before adding new features”</td></tr></tbody>",J,T,bt="<p><strong>Note:</strong> In the case of fine-tuned models for function-calling, the thought process is optional.<br/> <em>In case you’re not familiar with function-calling, there will be more detail in the Action section.</em></p>",V,k,X,_,$t="A key method is the <strong>ReAct approach</strong>, which is the concatenation of  “Reasoning” (Think) with “Acting” (Act).",Y,y,vt="ReAct is a simple prompting technique that appends “Let’s think step by step” before letting the LLM decode the next tokens.",Z,A,xt="Indeed, prompting the model to think “step by step” encourages the decoding process toward next tokens <strong>that generate a plan</strong>, rather than a final solution, since the model will <strong>decompose</strong> the problem into <em>sub-tasks</em>.",tt,C,wt="This allows the model to consider sub-steps in more detail, which in general leads to less errors than directly generating solution.",et,L,Tt='<img src="https://huggingface.co/datasets/agents-course/course-images/resolve/main/en/unit1/ReAct.png" alt="ReAct"/> <figcaption>The (d) is an example of Re-Act approach where we prompt &quot;Let&#39;s think step by step&quot;</figcaption>',nt,m,it,M,kt="<p><strong>Note</strong> : Those model have been fine-tuned to always include specific thinking ( enclosed in &lt;think&gt;&lt;/think&gt; special token). This is not a purely prompting technique like ReAct</p>",st,at,ot,R,_t="Now that we better understand the Thought process, let’s go deeper on the second part of the process: Act.",lt,H,rt,I,pt;return u=new Rt({props:{title:"Thought: Internal Reasoning and the Re-Act Approach",local:"thought-internal-reasoning-and-the-re-act-approach",headingTag:"h1"}}),c=new Mt({props:{$$slots:{default:[Bt]},$$scope:{ctx:P}}}),k=new Rt({props:{title:"The Re-Act Approach",local:"the-re-act-approach",headingTag:"h2"}}),m=new Mt({props:{$$slots:{default:[Gt]},$$scope:{ctx:P}}}),H=new jt({props:{source:"https://github.com/huggingface/agents-course/blob/main/units/en/unit1/thoughts.mdx"}}),{c(){o=l("meta"),p=s(),d=l("p"),B=s(),q(u.$$.fragment),G=s(),q(c.$$.fragment),U=s(),f=l("p"),f.innerHTML=ht,D=s(),g=l("p"),g.innerHTML=dt,N=s(),b=l("p"),b.textContent=ct,K=s(),$=l("p"),$.textContent=mt,Q=s(),v=l("p"),v.innerHTML=ut,W=s(),x=l("p"),x.textContent=ft,F=s(),w=l("table"),w.innerHTML=gt,J=s(),T=l("blockquote"),T.innerHTML=bt,V=s(),q(k.$$.fragment),X=s(),_=l("p"),_.innerHTML=$t,Y=s(),y=l("p"),y.textContent=vt,Z=s(),A=l("p"),A.innerHTML=xt,tt=s(),C=l("p"),C.textContent=wt,et=s(),L=l("figure"),L.innerHTML=Tt,nt=s(),q(m.$$.fragment),it=s(),M=l("blockquote"),M.innerHTML=kt,st=s(),at=l("hr"),ot=s(),R=l("p"),R.textContent=_t,lt=s(),q(H.$$.fragment),rt=s(),I=l("p"),this.h()},l(t){const e=Ot("svelte-u9bgzb",document.head);o=r(e,"META",{name:!0,content:!0}),e.forEach(n),p=a(t),d=r(t,"P",{}),Ct(d).forEach(n),B=a(t),z(u.$$.fragment,t),G=a(t),z(c.$$.fragment,t),U=a(t),f=r(t,"P",{"data-svelte-h":!0}),h(f)!=="svelte-1l9soxr"&&(f.innerHTML=ht),D=a(t),g=r(t,"P",{"data-svelte-h":!0}),h(g)!=="svelte-1ltaa94"&&(g.innerHTML=dt),N=a(t),b=r(t,"P",{"data-svelte-h":!0}),h(b)!=="svelte-qzqdp1"&&(b.textContent=ct),K=a(t),$=r(t,"P",{"data-svelte-h":!0}),h($)!=="svelte-1k69e4y"&&($.textContent=mt),Q=a(t),v=r(t,"P",{"data-svelte-h":!0}),h(v)!=="svelte-1ngchwc"&&(v.innerHTML=ut),W=a(t),x=r(t,"P",{"data-svelte-h":!0}),h(x)!=="svelte-ompwrf"&&(x.textContent=ft),F=a(t),w=r(t,"TABLE",{"data-svelte-h":!0}),h(w)!=="svelte-1efoj4x"&&(w.innerHTML=gt),J=a(t),T=r(t,"BLOCKQUOTE",{"data-svelte-h":!0}),h(T)!=="svelte-1vjs3i5"&&(T.innerHTML=bt),V=a(t),z(k.$$.fragment,t),X=a(t),_=r(t,"P",{"data-svelte-h":!0}),h(_)!=="svelte-xbnpor"&&(_.innerHTML=$t),Y=a(t),y=r(t,"P",{"data-svelte-h":!0}),h(y)!=="svelte-3stkhz"&&(y.textContent=vt),Z=a(t),A=r(t,"P",{"data-svelte-h":!0}),h(A)!=="svelte-y0c4nt"&&(A.innerHTML=xt),tt=a(t),C=r(t,"P",{"data-svelte-h":!0}),h(C)!=="svelte-13uzvop"&&(C.textContent=wt),et=a(t),L=r(t,"FIGURE",{"data-svelte-h":!0}),h(L)!=="svelte-d946n2"&&(L.innerHTML=Tt),nt=a(t),z(m.$$.fragment,t),it=a(t),M=r(t,"BLOCKQUOTE",{"data-svelte-h":!0}),h(M)!=="svelte-1vic6mc"&&(M.innerHTML=kt),st=a(t),at=r(t,"HR",{}),ot=a(t),R=r(t,"P",{"data-svelte-h":!0}),h(R)!=="svelte-4r07cc"&&(R.textContent=_t),lt=a(t),z(H.$$.fragment,t),rt=a(t),I=r(t,"P",{}),Ct(I).forEach(n),this.h()},h(){Lt(o,"name","hf:doc:metadata"),Lt(o,"content",Dt)},m(t,e){St(document.head,o),i(t,p,e),i(t,d,e),i(t,B,e),E(u,t,e),i(t,G,e),E(c,t,e),i(t,U,e),i(t,f,e),i(t,D,e),i(t,g,e),i(t,N,e),i(t,b,e),i(t,K,e),i(t,$,e),i(t,Q,e),i(t,v,e),i(t,W,e),i(t,x,e),i(t,F,e),i(t,w,e),i(t,J,e),i(t,T,e),i(t,V,e),E(k,t,e),i(t,X,e),i(t,_,e),i(t,Y,e),i(t,y,e),i(t,Z,e),i(t,A,e),i(t,tt,e),i(t,C,e),i(t,et,e),i(t,L,e),i(t,nt,e),E(m,t,e),i(t,it,e),i(t,M,e),i(t,st,e),i(t,at,e),i(t,ot,e),i(t,R,e),i(t,lt,e),E(H,t,e),i(t,rt,e),i(t,I,e),pt=!0},p(t,[e]){const yt={};e&2&&(yt.$$scope={dirty:e,ctx:t}),c.$set(yt);const At={};e&2&&(At.$$scope={dirty:e,ctx:t}),m.$set(At)},i(t){pt||(O(u.$$.fragment,t),O(c.$$.fragment,t),O(k.$$.fragment,t),O(m.$$.fragment,t),O(H.$$.fragment,t),pt=!0)},o(t){S(u.$$.fragment,t),S(c.$$.fragment,t),S(k.$$.fragment,t),S(m.$$.fragment,t),S(H.$$.fragment,t),pt=!1},d(t){t&&(n(p),n(d),n(B),n(G),n(U),n(f),n(D),n(g),n(N),n(b),n(K),n($),n(Q),n(v),n(W),n(x),n(F),n(w),n(J),n(T),n(V),n(X),n(_),n(Y),n(y),n(Z),n(A),n(tt),n(C),n(et),n(L),n(nt),n(it),n(M),n(st),n(at),n(ot),n(R),n(lt),n(rt),n(I)),n(o),j(u,t),j(c,t),j(k,t),j(m,t),j(H,t)}}}const Dt='{"title":"Thought: Internal Reasoning and the Re-Act Approach","local":"thought-internal-reasoning-and-the-re-act-approach","sections":[{"title":"The Re-Act Approach","local":"the-re-act-approach","sections":[],"depth":2}],"depth":1}';function Nt(P){return qt(()=>{new URLSearchParams(window.location.search).get("fw")}),[]}class Vt extends zt{constructor(o){super(),Et(this,o,Nt,Ut,It,{})}}export{Vt as component};
