import{s as ln,f as x,n as nn,o as sn}from"../chunks/scheduler.f6b352c8.js";import{S as an,i as on,g as a,s as i,r as p,A as rn,h as o,f as l,c as s,j as en,u as h,x as r,k as u,y as un,a as n,v as f,d as m,t as c,w as g}from"../chunks/index.7f38e934.js";import{C as pn}from"../chunks/CodeBlock.2a338b68.js";import{H as d}from"../chunks/Heading.333929c4.js";import{E as hn}from"../chunks/EditOnGithub.c3245a01.js";function fn(De){let v,qt,kt,Jt,C,Nt,w,Ke,Ot,T,tl="In the previous section, we learned:",Ut,A,el="<li><strong>How tools are made available to the agent in the system prompt</strong>.</li> <li>That AI agents are systems that can reason, plan, and interact with their environment.</li>",Et,M,ll="In this section, <strong>we’ll explore the complete AI Agent Workflow</strong>, a cycle we defined as Thought-Action-Observation.",Yt,$,nl="And then, we’ll dive deeper on each of these steps.",Gt,_,Wt,y,il="An Agent function in a continuous cycle of: <strong>thinking (Thought) → acting (Act) and observing (Observe)</strong>.",zt,b,sl="Let’s break down these actions together:",Ft,L,al="<li><strong>Thought</strong>: The LLM part of the Agent decides what the next step should be.</li> <li><strong>Action:</strong> The agent takes an action, by using the tools it wants to call with the associated arguments.</li> <li><strong>Observation:</strong> The agent reflects on the response from the tool.</li>",Rt,j,St,I,ol="The three components work together in a continuous loop. To use an analogy from programming, the agent uses a <strong>while loop</strong>: the loop continues until the objective of the agent has been fulfilled.",Bt,P,rl="Visually, it looks like this:",Qt,k,ul,Xt,H,pl="In many Agent frameworks, <strong>the rules and guidelines are embedded directly into the system prompt</strong>, ensuring that every cycle adheres to a defined logic.",Vt,q,hl="In an simplified version, our system prompt now looks like this:",Zt,J,fl,Dt,N,ml="We see here that in the System Message we defined :",Kt,O,cl="<li>The <em>Agent’s behavior</em>.</li> <li>The <em>Tools our Agent have access</em>.</li> <li>The <em>Thought-Action-Observation Cycle</em>.</li>",te,U,gl="Let’s take a small example to understand the process before going deeper into each step of the process.",ee,E,le,Y,vl="We created Alfred, the Weather Agent.",ne,G,xl="A user asks to Alfred: “What’s the weather like in New York today?”",ie,W,dl,se,z,Cl="Alfred’s job is to answer this query using a weather API tool.",ae,F,wl="Here’s how the cycle unfolds:",oe,R,re,S,Tl="<strong>Internal Reasoning:</strong>",ue,B,Al="Upon receiving the query, Alfred’s internal dialogue might be:",pe,Q,Ml="<em>“The user needs current weather information for New York. I have access to a tool that fetches weather data. First, I need to call the weather API to get up-to-date details.”</em>",he,X,$l="This step shows the agent breaking the problem into steps: first gathering the necessary data.",fe,V,_l,me,Z,ce,D,yl="<strong>Tool Usage:</strong>",ge,K,bl="Based on its reasoning, Alfred prepares a JSON-formatted command that calls the weather API tool. For example, its first action could be:",ve,tt,Ll="Thought: I need to check the current weather for New York.",xe,et,de,lt,jl="Here, the action clearly specifies which tool to call (e.g., get_weather) and what parameter to pass (the “location” : “New York”).",Ce,nt,Il,we,it,Te,st,Pl="<strong>Feedback from the Environment:</strong>",Ae,at,kl="After the tool call, Alfred receives an observation. This might be the raw weather data from the API such as:",Me,ot,Hl="<em>“Current weather in New York: partly cloudy, 15°C, 60% humidity.”</em>",$e,rt,ql,_e,ut,Jl="This observation is then added to the agent’s context. It functions as real-world feedback, confirming whether the action succeeded and providing the needed details.",ye,pt,be,ht,Nl="<strong>Reflecting:</strong>",Le,ft,Ol="With the observation in hand, Alfred updates its internal reasoning:",je,mt,Ul="<em>“Now that I have the weather data for New York, I can compile an answer for the user.”</em>",Ie,ct,El,Pe,gt,ke,vt,Yl="Alfred then generates a final response formatted in JSON:",He,xt,Gl="Thought :I have the weather data now. The current weather in New York is partly cloudy with a temperature of 15°C and 60% humidity.”",qe,dt,Wl="Final answer : The current weather in New York is partly cloudy with a temperature of 15°C and 60% humidity.",Je,Ct,zl="This final action sends the answer back to the user, closing the loop.",Ne,wt,Fl,Oe,Tt,Rl="What we see with example:",Ue,At,Sl="<li><strong>Agents cycle is a continuous loop until objective fullfilled:</strong></li>",Ee,Mt,Bl="<strong>Alfred’s process is cyclical</strong>. It starts with a thought, then acts by calling a tool, and finally observes the outcome. If the observation had indicated an error or incomplete data, Alfred could have re-entered the cycle to correct its approach.",Ye,$t,Ql="<li><strong>Tool Integration:</strong></li>",Ge,_t,Xl="The ability to call a tool (like a weather API) enables Alfred to go <strong>beyond static knowledge and retrieve real-time data</strong>, an essential aspect of many AI Agents.",We,yt,Vl="<li><strong>Dynamic Adaptation:</strong></li>",ze,bt,Zl="Each cycle allows the agent to incorporate fresh information (observations) into its reasoning (thought), ensuring that the final answer is well-informed and accurate.",Fe,Lt,Dl="This example showcase the core concept behind the <em>ReAct cycle</em> (a concept we’re going to develop in the next section): <strong>where the interplay of Thought, Action, and Observation empowers AI agents to solve complex tasks iteratively</strong>.",Re,jt,Kl="By understanding and applying these principles, you can design agents that not only reason about their tasks but also <strong>effectively utilize external tools to complete them</strong>, all while continuously refining their output based on environmental feedback.",Se,Be,Qe,It,tn="Let’s now dive deeper into Thought, Action, Observation down each step of the process",Xe,Pt,Ve,Ht,Ze;return C=new d({props:{title:"Understanding AI Agents through the Thought-Action-Observation Cycle",local:"understanding-ai-agents-through-the-thought-action-observation-cycle",headingTag:"h1"}}),_=new d({props:{title:"The Core Components",local:"the-core-components",headingTag:"h2"}}),j=new d({props:{title:"The Thought-Action-Observation Cycle",local:"the-thought-action-observation-cycle",headingTag:"h2"}}),E=new d({props:{title:"Alfred, the weather Agent",local:"alfred-the-weather-agent",headingTag:"h2"}}),R=new d({props:{title:"Thought",local:"thought",headingTag:"h3"}}),Z=new d({props:{title:"Action",local:"action",headingTag:"h3"}}),et=new pn({props:{code:"JTIwJTIwJTIwJTdCJTBBJTIwJTIwJTIwJTIwJTIwJTIyYWN0aW9uJTIyJTNBJTIwJTIyZ2V0X3dlYXRoZXIlMjIlMkMlMEElMjAlMjAlMjAlMjAlMjAlMjJhY3Rpb25faW5wdXQlMjIlM0ElMjAlN0IlMEElMjAlMjAlMjAlMjAlMjAlMjAlMjAlMjJsb2NhdGlvbiUyMiUzQSUyMCUyMk5ldyUyMFlvcmslMjIlMEElMjAlMjAlMjAlMjAlMjAlN0QlMEElMjAlMjAlMjAlN0Q=",highlighted:`   <span class="hljs-punctuation">{</span>
     <span class="hljs-attr">&quot;action&quot;</span><span class="hljs-punctuation">:</span> <span class="hljs-string">&quot;get_weather&quot;</span><span class="hljs-punctuation">,</span>
     <span class="hljs-attr">&quot;action_input&quot;</span><span class="hljs-punctuation">:</span> <span class="hljs-punctuation">{</span>
       <span class="hljs-attr">&quot;location&quot;</span><span class="hljs-punctuation">:</span> <span class="hljs-string">&quot;New York&quot;</span>
     <span class="hljs-punctuation">}</span>
   <span class="hljs-punctuation">}</span>`,wrap:!1}}),it=new d({props:{title:"Observation",local:"observation",headingTag:"h3"}}),pt=new d({props:{title:"Updated thought",local:"updated-thought",headingTag:"h3"}}),gt=new d({props:{title:"Final Action",local:"final-action",headingTag:"h3"}}),Pt=new hn({props:{source:"https://github.com/huggingface/agents-course/blob/main/units/en/unit1/agent-steps-and-structure.mdx"}}),{c(){v=a("meta"),qt=i(),kt=a("p"),Jt=i(),p(C.$$.fragment),Nt=i(),w=a("img"),Ot=i(),T=a("p"),T.textContent=tl,Ut=i(),A=a("ul"),A.innerHTML=el,Et=i(),M=a("p"),M.innerHTML=ll,Yt=i(),$=a("p"),$.textContent=nl,Gt=i(),p(_.$$.fragment),Wt=i(),y=a("p"),y.innerHTML=il,zt=i(),b=a("p"),b.textContent=sl,Ft=i(),L=a("ol"),L.innerHTML=al,Rt=i(),p(j.$$.fragment),St=i(),I=a("p"),I.innerHTML=ol,Bt=i(),P=a("p"),P.textContent=rl,Qt=i(),k=a("img"),Xt=i(),H=a("p"),H.innerHTML=pl,Vt=i(),q=a("p"),q.textContent=hl,Zt=i(),J=a("img"),Dt=i(),N=a("p"),N.textContent=ml,Kt=i(),O=a("ul"),O.innerHTML=cl,te=i(),U=a("p"),U.textContent=gl,ee=i(),p(E.$$.fragment),le=i(),Y=a("p"),Y.textContent=vl,ne=i(),G=a("p"),G.textContent=xl,ie=i(),W=a("img"),se=i(),z=a("p"),z.textContent=Cl,ae=i(),F=a("p"),F.textContent=wl,oe=i(),p(R.$$.fragment),re=i(),S=a("p"),S.innerHTML=Tl,ue=i(),B=a("p"),B.textContent=Al,pe=i(),Q=a("p"),Q.innerHTML=Ml,he=i(),X=a("p"),X.textContent=$l,fe=i(),V=a("img"),me=i(),p(Z.$$.fragment),ce=i(),D=a("p"),D.innerHTML=yl,ge=i(),K=a("p"),K.textContent=bl,ve=i(),tt=a("p"),tt.textContent=Ll,xe=i(),p(et.$$.fragment),de=i(),lt=a("p"),lt.textContent=jl,Ce=i(),nt=a("img"),we=i(),p(it.$$.fragment),Te=i(),st=a("p"),st.innerHTML=Pl,Ae=i(),at=a("p"),at.textContent=kl,Me=i(),ot=a("p"),ot.innerHTML=Hl,$e=i(),rt=a("img"),_e=i(),ut=a("p"),ut.textContent=Jl,ye=i(),p(pt.$$.fragment),be=i(),ht=a("p"),ht.innerHTML=Nl,Le=i(),ft=a("p"),ft.textContent=Ol,je=i(),mt=a("p"),mt.innerHTML=Ul,Ie=i(),ct=a("img"),Pe=i(),p(gt.$$.fragment),ke=i(),vt=a("p"),vt.textContent=Yl,He=i(),xt=a("p"),xt.textContent=Gl,qe=i(),dt=a("p"),dt.textContent=Wl,Je=i(),Ct=a("p"),Ct.textContent=zl,Ne=i(),wt=a("img"),Oe=i(),Tt=a("p"),Tt.textContent=Rl,Ue=i(),At=a("ul"),At.innerHTML=Sl,Ee=i(),Mt=a("p"),Mt.innerHTML=Bl,Ye=i(),$t=a("ul"),$t.innerHTML=Ql,Ge=i(),_t=a("p"),_t.innerHTML=Xl,We=i(),yt=a("ul"),yt.innerHTML=Vl,ze=i(),bt=a("p"),bt.textContent=Zl,Fe=i(),Lt=a("p"),Lt.innerHTML=Dl,Re=i(),jt=a("p"),jt.innerHTML=Kl,Se=i(),Be=a("hr"),Qe=i(),It=a("p"),It.textContent=tn,Xe=i(),p(Pt.$$.fragment),Ve=i(),Ht=a("p"),this.h()},l(t){const e=rn("svelte-u9bgzb",document.head);v=o(e,"META",{name:!0,content:!0}),e.forEach(l),qt=s(t),kt=o(t,"P",{}),en(kt).forEach(l),Jt=s(t),h(C.$$.fragment,t),Nt=s(t),w=o(t,"IMG",{src:!0,alt:!0}),Ot=s(t),T=o(t,"P",{"data-svelte-h":!0}),r(T)!=="svelte-17ch00b"&&(T.textContent=tl),Ut=s(t),A=o(t,"UL",{"data-svelte-h":!0}),r(A)!=="svelte-70frir"&&(A.innerHTML=el),Et=s(t),M=o(t,"P",{"data-svelte-h":!0}),r(M)!=="svelte-1dokcbw"&&(M.innerHTML=ll),Yt=s(t),$=o(t,"P",{"data-svelte-h":!0}),r($)!=="svelte-14c74an"&&($.textContent=nl),Gt=s(t),h(_.$$.fragment,t),Wt=s(t),y=o(t,"P",{"data-svelte-h":!0}),r(y)!=="svelte-1c1jmhd"&&(y.innerHTML=il),zt=s(t),b=o(t,"P",{"data-svelte-h":!0}),r(b)!=="svelte-optv5e"&&(b.textContent=sl),Ft=s(t),L=o(t,"OL",{"data-svelte-h":!0}),r(L)!=="svelte-1pdcylu"&&(L.innerHTML=al),Rt=s(t),h(j.$$.fragment,t),St=s(t),I=o(t,"P",{"data-svelte-h":!0}),r(I)!=="svelte-1qe4h0s"&&(I.innerHTML=ol),Bt=s(t),P=o(t,"P",{"data-svelte-h":!0}),r(P)!=="svelte-s2kplf"&&(P.textContent=rl),Qt=s(t),k=o(t,"IMG",{src:!0,alt:!0}),Xt=s(t),H=o(t,"P",{"data-svelte-h":!0}),r(H)!=="svelte-i9knc1"&&(H.innerHTML=pl),Vt=s(t),q=o(t,"P",{"data-svelte-h":!0}),r(q)!=="svelte-yi1ahc"&&(q.textContent=hl),Zt=s(t),J=o(t,"IMG",{src:!0,alt:!0}),Dt=s(t),N=o(t,"P",{"data-svelte-h":!0}),r(N)!=="svelte-e5pmx1"&&(N.textContent=ml),Kt=s(t),O=o(t,"UL",{"data-svelte-h":!0}),r(O)!=="svelte-1pqnwe7"&&(O.innerHTML=cl),te=s(t),U=o(t,"P",{"data-svelte-h":!0}),r(U)!=="svelte-1tsmln9"&&(U.textContent=gl),ee=s(t),h(E.$$.fragment,t),le=s(t),Y=o(t,"P",{"data-svelte-h":!0}),r(Y)!=="svelte-1232lbo"&&(Y.textContent=vl),ne=s(t),G=o(t,"P",{"data-svelte-h":!0}),r(G)!=="svelte-hk3vzw"&&(G.textContent=xl),ie=s(t),W=o(t,"IMG",{src:!0,alt:!0}),se=s(t),z=o(t,"P",{"data-svelte-h":!0}),r(z)!=="svelte-1yedpwx"&&(z.textContent=Cl),ae=s(t),F=o(t,"P",{"data-svelte-h":!0}),r(F)!=="svelte-82uzmq"&&(F.textContent=wl),oe=s(t),h(R.$$.fragment,t),re=s(t),S=o(t,"P",{"data-svelte-h":!0}),r(S)!=="svelte-bbakro"&&(S.innerHTML=Tl),ue=s(t),B=o(t,"P",{"data-svelte-h":!0}),r(B)!=="svelte-x8n7iu"&&(B.textContent=Al),pe=s(t),Q=o(t,"P",{"data-svelte-h":!0}),r(Q)!=="svelte-1rwco72"&&(Q.innerHTML=Ml),he=s(t),X=o(t,"P",{"data-svelte-h":!0}),r(X)!=="svelte-wbgtl"&&(X.textContent=$l),fe=s(t),V=o(t,"IMG",{src:!0,alt:!0}),me=s(t),h(Z.$$.fragment,t),ce=s(t),D=o(t,"P",{"data-svelte-h":!0}),r(D)!=="svelte-15s12fo"&&(D.innerHTML=yl),ge=s(t),K=o(t,"P",{"data-svelte-h":!0}),r(K)!=="svelte-1c8crkz"&&(K.textContent=bl),ve=s(t),tt=o(t,"P",{"data-svelte-h":!0}),r(tt)!=="svelte-rqzrlx"&&(tt.textContent=Ll),xe=s(t),h(et.$$.fragment,t),de=s(t),lt=o(t,"P",{"data-svelte-h":!0}),r(lt)!=="svelte-42xtu6"&&(lt.textContent=jl),Ce=s(t),nt=o(t,"IMG",{src:!0,alt:!0}),we=s(t),h(it.$$.fragment,t),Te=s(t),st=o(t,"P",{"data-svelte-h":!0}),r(st)!=="svelte-xv12jk"&&(st.innerHTML=Pl),Ae=s(t),at=o(t,"P",{"data-svelte-h":!0}),r(at)!=="svelte-f8am0x"&&(at.textContent=kl),Me=s(t),ot=o(t,"P",{"data-svelte-h":!0}),r(ot)!=="svelte-17ah7xm"&&(ot.innerHTML=Hl),$e=s(t),rt=o(t,"IMG",{src:!0,alt:!0}),_e=s(t),ut=o(t,"P",{"data-svelte-h":!0}),r(ut)!=="svelte-4ntnwx"&&(ut.textContent=Jl),ye=s(t),h(pt.$$.fragment,t),be=s(t),ht=o(t,"P",{"data-svelte-h":!0}),r(ht)!=="svelte-thyb76"&&(ht.innerHTML=Nl),Le=s(t),ft=o(t,"P",{"data-svelte-h":!0}),r(ft)!=="svelte-12w4wqc"&&(ft.textContent=Ol),je=s(t),mt=o(t,"P",{"data-svelte-h":!0}),r(mt)!=="svelte-26gu5r"&&(mt.innerHTML=Ul),Ie=s(t),ct=o(t,"IMG",{src:!0,alt:!0}),Pe=s(t),h(gt.$$.fragment,t),ke=s(t),vt=o(t,"P",{"data-svelte-h":!0}),r(vt)!=="svelte-ukbity"&&(vt.textContent=Yl),He=s(t),xt=o(t,"P",{"data-svelte-h":!0}),r(xt)!=="svelte-2elx9s"&&(xt.textContent=Gl),qe=s(t),dt=o(t,"P",{"data-svelte-h":!0}),r(dt)!=="svelte-1pdvdow"&&(dt.textContent=Wl),Je=s(t),Ct=o(t,"P",{"data-svelte-h":!0}),r(Ct)!=="svelte-1o695ae"&&(Ct.textContent=zl),Ne=s(t),wt=o(t,"IMG",{src:!0,alt:!0}),Oe=s(t),Tt=o(t,"P",{"data-svelte-h":!0}),r(Tt)!=="svelte-y7tesx"&&(Tt.textContent=Rl),Ue=s(t),At=o(t,"UL",{"data-svelte-h":!0}),r(At)!=="svelte-ov17o4"&&(At.innerHTML=Sl),Ee=s(t),Mt=o(t,"P",{"data-svelte-h":!0}),r(Mt)!=="svelte-iiv7bs"&&(Mt.innerHTML=Bl),Ye=s(t),$t=o(t,"UL",{"data-svelte-h":!0}),r($t)!=="svelte-16xux1s"&&($t.innerHTML=Ql),Ge=s(t),_t=o(t,"P",{"data-svelte-h":!0}),r(_t)!=="svelte-9n1qd1"&&(_t.innerHTML=Xl),We=s(t),yt=o(t,"UL",{"data-svelte-h":!0}),r(yt)!=="svelte-hbr0le"&&(yt.innerHTML=Vl),ze=s(t),bt=o(t,"P",{"data-svelte-h":!0}),r(bt)!=="svelte-1e08iqd"&&(bt.textContent=Zl),Fe=s(t),Lt=o(t,"P",{"data-svelte-h":!0}),r(Lt)!=="svelte-11bqhq8"&&(Lt.innerHTML=Dl),Re=s(t),jt=o(t,"P",{"data-svelte-h":!0}),r(jt)!=="svelte-2zcn5x"&&(jt.innerHTML=Kl),Se=s(t),Be=o(t,"HR",{}),Qe=s(t),It=o(t,"P",{"data-svelte-h":!0}),r(It)!=="svelte-v9d07r"&&(It.textContent=tn),Xe=s(t),h(Pt.$$.fragment,t),Ve=s(t),Ht=o(t,"P",{}),en(Ht).forEach(l),this.h()},h(){u(v,"name","hf:doc:metadata"),u(v,"content",mn),x(w.src,Ke="https://huggingface.co/datasets/agents-course/course-images/resolve/main/en/unit1/whiteboard-check-3.jpg")||u(w,"src",Ke),u(w,"alt","Unit 1 planning"),x(k.src,ul="https://huggingface.co/datasets/agents-course/course-images/resolve/main/en/unit1/AgentCycle.gif")||u(k,"src",ul),u(k,"alt","Think, Act, Observe cycle"),x(J.src,fl="https://huggingface.co/datasets/agents-course/course-images/resolve/main/en/unit1/system_prompt_cycle.png")||u(J,"src",fl),u(J,"alt","Think, Act, Observe cycle"),x(W.src,dl="https://huggingface.co/datasets/agents-course/course-images/resolve/main/en/unit1/alfred-agent.jpg")||u(W,"src",dl),u(W,"alt","Alfred Agent"),x(V.src,_l="https://huggingface.co/datasets/agents-course/course-images/resolve/main/en/unit1/alfred-agent-1.jpg")||u(V,"src",_l),u(V,"alt","Alfred Agent"),x(nt.src,Il="https://huggingface.co/datasets/agents-course/course-images/resolve/main/en/unit1/alfred-agent-2.jpg")||u(nt,"src",Il),u(nt,"alt","Alfred Agent"),x(rt.src,ql="https://huggingface.co/datasets/agents-course/course-images/resolve/main/en/unit1/alfred-agent-3.jpg")||u(rt,"src",ql),u(rt,"alt","Alfred Agent"),x(ct.src,El="https://huggingface.co/datasets/agents-course/course-images/resolve/main/en/unit1/alfred-agent-4.jpg")||u(ct,"src",El),u(ct,"alt","Alfred Agent"),x(wt.src,Fl="https://huggingface.co/datasets/agents-course/course-images/resolve/main/en/unit1/alfred-agent-5.jpg")||u(wt,"src",Fl),u(wt,"alt","Alfred Agent")},m(t,e){un(document.head,v),n(t,qt,e),n(t,kt,e),n(t,Jt,e),f(C,t,e),n(t,Nt,e),n(t,w,e),n(t,Ot,e),n(t,T,e),n(t,Ut,e),n(t,A,e),n(t,Et,e),n(t,M,e),n(t,Yt,e),n(t,$,e),n(t,Gt,e),f(_,t,e),n(t,Wt,e),n(t,y,e),n(t,zt,e),n(t,b,e),n(t,Ft,e),n(t,L,e),n(t,Rt,e),f(j,t,e),n(t,St,e),n(t,I,e),n(t,Bt,e),n(t,P,e),n(t,Qt,e),n(t,k,e),n(t,Xt,e),n(t,H,e),n(t,Vt,e),n(t,q,e),n(t,Zt,e),n(t,J,e),n(t,Dt,e),n(t,N,e),n(t,Kt,e),n(t,O,e),n(t,te,e),n(t,U,e),n(t,ee,e),f(E,t,e),n(t,le,e),n(t,Y,e),n(t,ne,e),n(t,G,e),n(t,ie,e),n(t,W,e),n(t,se,e),n(t,z,e),n(t,ae,e),n(t,F,e),n(t,oe,e),f(R,t,e),n(t,re,e),n(t,S,e),n(t,ue,e),n(t,B,e),n(t,pe,e),n(t,Q,e),n(t,he,e),n(t,X,e),n(t,fe,e),n(t,V,e),n(t,me,e),f(Z,t,e),n(t,ce,e),n(t,D,e),n(t,ge,e),n(t,K,e),n(t,ve,e),n(t,tt,e),n(t,xe,e),f(et,t,e),n(t,de,e),n(t,lt,e),n(t,Ce,e),n(t,nt,e),n(t,we,e),f(it,t,e),n(t,Te,e),n(t,st,e),n(t,Ae,e),n(t,at,e),n(t,Me,e),n(t,ot,e),n(t,$e,e),n(t,rt,e),n(t,_e,e),n(t,ut,e),n(t,ye,e),f(pt,t,e),n(t,be,e),n(t,ht,e),n(t,Le,e),n(t,ft,e),n(t,je,e),n(t,mt,e),n(t,Ie,e),n(t,ct,e),n(t,Pe,e),f(gt,t,e),n(t,ke,e),n(t,vt,e),n(t,He,e),n(t,xt,e),n(t,qe,e),n(t,dt,e),n(t,Je,e),n(t,Ct,e),n(t,Ne,e),n(t,wt,e),n(t,Oe,e),n(t,Tt,e),n(t,Ue,e),n(t,At,e),n(t,Ee,e),n(t,Mt,e),n(t,Ye,e),n(t,$t,e),n(t,Ge,e),n(t,_t,e),n(t,We,e),n(t,yt,e),n(t,ze,e),n(t,bt,e),n(t,Fe,e),n(t,Lt,e),n(t,Re,e),n(t,jt,e),n(t,Se,e),n(t,Be,e),n(t,Qe,e),n(t,It,e),n(t,Xe,e),f(Pt,t,e),n(t,Ve,e),n(t,Ht,e),Ze=!0},p:nn,i(t){Ze||(m(C.$$.fragment,t),m(_.$$.fragment,t),m(j.$$.fragment,t),m(E.$$.fragment,t),m(R.$$.fragment,t),m(Z.$$.fragment,t),m(et.$$.fragment,t),m(it.$$.fragment,t),m(pt.$$.fragment,t),m(gt.$$.fragment,t),m(Pt.$$.fragment,t),Ze=!0)},o(t){c(C.$$.fragment,t),c(_.$$.fragment,t),c(j.$$.fragment,t),c(E.$$.fragment,t),c(R.$$.fragment,t),c(Z.$$.fragment,t),c(et.$$.fragment,t),c(it.$$.fragment,t),c(pt.$$.fragment,t),c(gt.$$.fragment,t),c(Pt.$$.fragment,t),Ze=!1},d(t){t&&(l(qt),l(kt),l(Jt),l(Nt),l(w),l(Ot),l(T),l(Ut),l(A),l(Et),l(M),l(Yt),l($),l(Gt),l(Wt),l(y),l(zt),l(b),l(Ft),l(L),l(Rt),l(St),l(I),l(Bt),l(P),l(Qt),l(k),l(Xt),l(H),l(Vt),l(q),l(Zt),l(J),l(Dt),l(N),l(Kt),l(O),l(te),l(U),l(ee),l(le),l(Y),l(ne),l(G),l(ie),l(W),l(se),l(z),l(ae),l(F),l(oe),l(re),l(S),l(ue),l(B),l(pe),l(Q),l(he),l(X),l(fe),l(V),l(me),l(ce),l(D),l(ge),l(K),l(ve),l(tt),l(xe),l(de),l(lt),l(Ce),l(nt),l(we),l(Te),l(st),l(Ae),l(at),l(Me),l(ot),l($e),l(rt),l(_e),l(ut),l(ye),l(be),l(ht),l(Le),l(ft),l(je),l(mt),l(Ie),l(ct),l(Pe),l(ke),l(vt),l(He),l(xt),l(qe),l(dt),l(Je),l(Ct),l(Ne),l(wt),l(Oe),l(Tt),l(Ue),l(At),l(Ee),l(Mt),l(Ye),l($t),l(Ge),l(_t),l(We),l(yt),l(ze),l(bt),l(Fe),l(Lt),l(Re),l(jt),l(Se),l(Be),l(Qe),l(It),l(Xe),l(Ve),l(Ht)),l(v),g(C,t),g(_,t),g(j,t),g(E,t),g(R,t),g(Z,t),g(et,t),g(it,t),g(pt,t),g(gt,t),g(Pt,t)}}}const mn='{"title":"Understanding AI Agents through the Thought-Action-Observation Cycle","local":"understanding-ai-agents-through-the-thought-action-observation-cycle","sections":[{"title":"The Core Components","local":"the-core-components","sections":[],"depth":2},{"title":"The Thought-Action-Observation Cycle","local":"the-thought-action-observation-cycle","sections":[],"depth":2},{"title":"Alfred, the weather Agent","local":"alfred-the-weather-agent","sections":[{"title":"Thought","local":"thought","sections":[],"depth":3},{"title":"Action","local":"action","sections":[],"depth":3},{"title":"Observation","local":"observation","sections":[],"depth":3},{"title":"Updated thought","local":"updated-thought","sections":[],"depth":3},{"title":"Final Action","local":"final-action","sections":[],"depth":3}],"depth":2}],"depth":1}';function cn(De){return sn(()=>{new URLSearchParams(window.location.search).get("fw")}),[]}class wn extends an{constructor(v){super(),on(this,v,cn,fn,ln,{})}}export{wn as component};
